Package: Meanimiles
Title: Estimation of Meanimiles
Version: 0.1.0
Authors@R: c(
    person("Dieter", "Debrauwer", , "dieter.debrauwer@kuleuven.be", role = c("aut", "cre","cph"),
    comment=c(ORCID="0000-0002-0171-1045")),
     person("Irène", "Gijbels",, email = "irene.gijbels@kuleuven.be", role = "ctb",
           comment = c(ORCID = "0000-0002-4443-9803")),
    person("Klaus", "Herrmann",, email = "klaus.herrmann@usherbrooke.ca", role = "ctb",
    comment = c(ORCID = "0000-0002-8044-5717")))
Description: Provides a comprehensive suite of estimation tools for meanimiles, 
    a general class of (risk) functionals. This package includes nonparametric 
    estimators for univariate meanimile evaluation, copula-based estimation 
    for portfolio risk aggregation (full parametric, semiparametric, and nonparametric),
    and novel estimators for meanimiles in regression settings. 
    Following the articles D. Debrauwer, I. Gijbels, and K. Herrmann (2025)
    <doi:10.1214/25-EJS2391>, D. Debrauwer and I. Gijbels (2026)
    <doi:10.1007/s00184-026-01022-9>.
License: GPL (>= 3)
Encoding: UTF-8
RoxygenNote: 7.3.3
URL: https://github.com/DieterDebrauwer/Meanimiles
BugReports: https://github.com/DieterDebrauwer/Meanimiles/issues
Depends: R (>= 4.5.0)
Imports: copula (>= 1.1.7), fitdistrplus (>= 1.2.6), stats
Suggests: knitr, rmarkdown
NeedsCompilation: no
Packaged: 2026-04-16 14:24:40 UTC; u0156046
Author: Dieter Debrauwer [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0002-0171-1045>),
  Irène Gijbels [ctb] (ORCID: <https://orcid.org/0000-0002-4443-9803>),
  Klaus Herrmann [ctb] (ORCID: <https://orcid.org/0000-0002-8044-5717>)
Maintainer: Dieter Debrauwer <dieter.debrauwer@kuleuven.be>
Repository: CRAN
Date/Publication: 2026-04-21 18:42:45 UTC
Built: R 4.5.2; ; 2026-04-21 22:37:59 UTC; unix

Package: Meanimiles
Title: Estimation of Meanimiles
Version: 0.1.0
Authors@R: c(
    person("Dieter", "Debrauwer", , "dieter.debrauwer@kuleuven.be", role = c("aut", "cre","cph"),
    comment=c(ORCID="0000-0002-0171-1045")),
     person("Irène", "Gijbels",, email = "irene.gijbels@kuleuven.be", role = "ctb",
           comment = c(ORCID = "0000-0002-4443-9803")),
    person("Klaus", "Herrmann",, email = "klaus.herrmann@usherbrooke.ca", role = "ctb",
    comment = c(ORCID = "0000-0002-8044-5717")))
Description: Provides a comprehensive suite of estimation tools for meanimiles, 
    a general class of (risk) functionals. This package includes nonparametric 
    estimators for univariate meanimile evaluation, copula-based estimation 
    for portfolio risk aggregation (full parametric, semiparametric, and nonparametric),
    and novel estimators for meanimiles in regression settings. 
    Following the articles D. Debrauwer, I. Gijbels, and K. Herrmann (2025)
    <doi:10.1214/25-EJS2391>, D. Debrauwer and I. Gijbels (2026)
    <doi:10.1007/s00184-026-01022-9>.
License: GPL (>= 3)
Encoding: UTF-8
RoxygenNote: 7.3.3
URL: https://github.com/DieterDebrauwer/Meanimiles
BugReports: https://github.com/DieterDebrauwer/Meanimiles/issues
Depends: R (>= 4.5.0)
Imports: copula (>= 1.1.7), fitdistrplus (>= 1.2.6), stats
Suggests: knitr, rmarkdown
NeedsCompilation: no
Packaged: 2026-04-16 14:24:40 UTC; u0156046
Author: Dieter Debrauwer [aut, cre, cph] (ORCID:
    <https://orcid.org/0000-0002-0171-1045>),
  Irène Gijbels [ctb] (ORCID: <https://orcid.org/0000-0002-4443-9803>),
  Klaus Herrmann [ctb] (ORCID: <https://orcid.org/0000-0002-8044-5717>)
Maintainer: Dieter Debrauwer <dieter.debrauwer@kuleuven.be>
Repository: CRAN
Date/Publication: 2026-04-21 18:42:45 UTC
Built: R 4.6.0; ; 2026-04-26 04:09:29 UTC; unix

# Meanimiles

This R package provides tools for the statistical estimation of
meanimiles, a general and flexible class of (risk) functionals that
unifies quantiles, expectiles, and extremiles.

In particular, nonparametric estimators for univariate meanimile are
implemented, as introduced and studied in:

- Debrauwer, D., Gijbels, I., & Herrmann, K. (2025). On a general class
  of functionals: Statistical inference and application to risk
  measures. *Electronic Journal of Statistics*, 19(1), 2456-2510. doi:
  [10.1214/25-EJS2391](https://doi.org/10.1214/25-EJS2391).

Furthermore, the package includes several copula-based estimation
procedures for portfolio risk aggregation. These accommodate parametric
and nonparametric methods for both margins and dependence structures, as
investigated in:

- Debrauwer, D. & Gijbels, I. (2026). Copula-based estimation of
  meanimiles of aggregated risks. *Metrika*. doi:
  [10.1007/s00184-026-01022-9](https://doi.org/10.1007/s00184-026-01022-9).

Finally, novel estimators for meanimiles in regression settings are
implemented as well.

#' @title Estimate conditional cumulative distribution function
#'
#' @description
#'    Computes a doubly smoothed Nadaraya-Watson estimator for the conditional
#'    cumulative distribution function.
#'
#' @param Y_eval A numeric vector of Y values where the CDF should be evaluated.
#' @param X_eval A numeric matrix of X values where the CDF should be evaluated.
#' @param Y_train A numeric vector of training Y values.
#' @param X_train A numeric matrix of training X values.
#' @param h_y A numeric scalar representing the bandwidth for the
#'    response variable Y.
#' @param h_x A numeric vector representing the bandwidths for the covariates X.
#'
#' @return A numeric vector of estimated CDF probabilities.
#' @export
ConditionalCDF <- function(Y_eval, X_eval, Y_train, X_train, h_y, h_x) {
  X_eval <- as.matrix(X_eval)
  X_train <- as.matrix(X_train)

  n_eval <- nrow(X_eval)
  n_train <- nrow(X_train)
  d <- ncol(X_train)

  if (length(h_x) == 1) h_x <- rep(h_x, d)

  # Initialize the weight matrix with 1s (size: n_eval x n_train)
  W <- matrix(1, nrow = n_eval, ncol = n_train)

  # Vectorized computation for all covariate dimensions
  for (k in seq_len(d)) {
    # outer() creates an n_eval x n_train matrix of all pairwise differences
    K_k <- stats::dnorm(outer(X_eval[, k], X_train[, k], "-") / h_x[k])
    W <- W * K_k # Element-wise multiplication
  }

  # Vectorized computation for the Y response
  # We use outer() here too to ensure we get the full n_eval x n_train matrix
  W_y <- stats::pnorm(outer(Y_eval, Y_train, "-") / h_y)

  # Nadaraya-Watson combination using rowSums
  numerator <- rowSums(W * W_y)
  denominator <- rowSums(W)

  # Calculate final CDF and handle division by zero
  F_hat <- numerator / denominator
  F_hat[denominator < 1e-12] <- 0

  return(F_hat)
}

#' @title Estimate linear conditional meanimile
#'
#' @description
#'    Estimates the parameters of a linear conditional meanimile model using a two-fold
#'    sample splitting procedure to mitigate bias from the conditional CDF estimation.
#'    This function acts as a unified wrapper, allowing the user to seamlessly switch
#'    between the square loss formulation and the general loss formulation.
#'
#' @param X A numeric matrix of covariates (n x d).
#' @param Y A numeric vector of the response variable.
#' @param d_tau A function representing the density function of the
#'    distributional weight function D_tau.
#' @param tau A numeric risk level/index. Argument of d_tau function.
#' @param h_x A numeric vector of bandwidths for the covariates X.
#' @param h_y A numeric scalar bandwidth for the response variable Y.
#' @param loss_type A character string specifying the loss formulation. Must be either \code{"square"} (default) or \code{"general"}.
#' @param lossDerivative A function defining the derivative of the loss function. Required only if \code{loss_type = "general"}.
#' @param delta Optional numeric parameter for the loss function. Used only if \code{loss_type = "general"}.
#'
#' @return A numeric vector of estimated regression coefficients (including the intercept).
#' @export
#'
#' @examples
#' set.seed(123)
#' n <- 400
#' X <- matrix(rnorm(n * 2), ncol = 2)
#' Y <- 0.9 * X[, 1] + 0.5 * X[, 2] + rnorm(n)
#' d_tau_minvar <- function(u, tau) {
#'   (tau + 1) * u^tau
#' }
#' lossDerivativeExpectiles <- function(x, c, delta) {
#'   -2 * ifelse(x > c, delta, 1 - delta) * (x - c)
#' }
#'
#' # 1. Square Loss
#' MeanimileLinearRegression(X, Y,
#'   d_tau = d_tau_minvar, tau = 2,
#'   h_x = c(0.4, 0.4), h_y = 0.4, loss_type = "square"
#' )
#'
#' # 2. General Loss
#' MeanimileLinearRegression(X, Y,
#'   d_tau = d_tau_minvar, tau = 2,
#'   h_x = c(0.4, 0.4), h_y = 0.4, loss_type = "general",
#'   lossDerivative = lossDerivativeExpectiles, delta = 0.9
#' )
MeanimileLinearRegression <- function(X, Y, d_tau, tau, h_x, h_y,
                                      loss_type = c("square", "general"),
                                      lossDerivative = NULL, delta = NULL) {
  # Ensure the user picks a valid option, defaults to "square"
  loss_type <- match.arg(loss_type)

  # Route to the correct internal engine
  if (loss_type == "square") {
    return(fit_linear_square(X, Y, d_tau, tau, h_x, h_y))
  } else if (loss_type == "general") {
    if (is.null(lossDerivative)) {
      stop("You must provide 'lossDerivative' when using loss_type = 'general'.")
    }
    return(fit_linear_general(X, Y, d_tau, tau, h_x, h_y, lossDerivative, delta))
  }
}

# -------------------------------------------------------------------------
# Internal Engine: Square Loss
# -------------------------------------------------------------------------
fit_linear_square <- function(X, Y, d_tau, tau, h_x, h_y) {
  X <- as.matrix(X)
  n <- nrow(X)
  X_G <- cbind(1, X)

  # SAFE COLUMN NAMING
  if (is.null(colnames(X))) {
    colnames(X_G) <- c("(Intercept)", paste0("X", seq_len(ncol(X))))
  } else {
    colnames(X_G) <- c("(Intercept)", colnames(X))
  }

  indices <- sample(seq_len(n))
  split_point <- floor(n / 2)
  idx_S1 <- indices[1:split_point]
  idx_S2 <- indices[(split_point + 1):n]

  # Fold 1
  F_hat_S2 <- ConditionalCDF(Y[idx_S2], X[idx_S2, , drop = FALSE], Y[idx_S1], X[idx_S1, , drop = FALSE], h_y, h_x)
  W_S2 <- d_tau(F_hat_S2, tau)
  valid_S2 <- !is.na(W_S2)
  fit_S2 <- stats::lm.wfit(
    x = X_G[idx_S2, , drop = FALSE][valid_S2, , drop = FALSE],
    y = Y[idx_S2][valid_S2], w = W_S2[valid_S2]
  )
  beta_2 <- fit_S2$coefficients

  # Fold 2
  F_hat_S1 <- ConditionalCDF(Y[idx_S1], X[idx_S1, , drop = FALSE], Y[idx_S2], X[idx_S2, , drop = FALSE], h_y, h_x)
  W_S1 <- d_tau(F_hat_S1, tau)
  valid_S1 <- !is.na(W_S1)
  fit_S1 <- stats::lm.wfit(
    x = X_G[idx_S1, , drop = FALSE][valid_S1, , drop = FALSE],
    y = Y[idx_S1][valid_S1], w = W_S1[valid_S1]
  )
  beta_1 <- fit_S1$coefficients

  return((beta_1 + beta_2) / 2)
}


fit_linear_general <- function(X, Y, d_tau, tau, h_x, h_y, lossDerivative, delta) {
  X <- as.matrix(X)
  n <- nrow(X)
  X_G <- cbind(1, X)

  #  SAFE COLUMN NAMING
  if (is.null(colnames(X))) {
    colnames(X_G) <- c("(Intercept)", paste0("X", seq_len(ncol(X))))
  } else {
    colnames(X_G) <- c("(Intercept)", colnames(X))
  }


  indices <- sample(seq_len(n))
  split_point <- floor(n / 2)
  idx_S1 <- indices[1:split_point]
  idx_S2 <- indices[(split_point + 1):n]


  # Helper function to solve the estimating equations for a given fold
  solve_fold <- function(idx_eval, idx_train) {
    F_hat <- ConditionalCDF(
      Y[idx_eval], X[idx_eval, , drop = FALSE],
      Y[idx_train], X[idx_train, , drop = FALSE], h_y, h_x
    )
    W <- d_tau(F_hat, tau)
    valid <- !is.na(W)

    Y_val <- Y[idx_eval][valid]
    X_val <- X_G[idx_eval, , drop = FALSE][valid, , drop = FALSE]
    W_val <- W[valid]

    # We want to find beta such that the sum of the estimating equations is zero.
    obj_fun <- function(beta) {
      preds <- as.vector(X_val %*% beta)
      if (is.null(delta)) {
        derivs <- lossDerivative(Y_val, preds)
      } else {
        derivs <- lossDerivative(Y_val, preds, delta)
      }
      eq_sums <- colSums(X_val * (W_val * derivs))
      return(sum(eq_sums^2))
    }

    start_beta <- stats::lm.fit(x = X_val, y = Y_val)$coefficients
    start_beta[is.na(start_beta)] <- 0

    opt_res <- stats::optim(par = start_beta, fn = obj_fun, method = "BFGS")
    return(opt_res$par)
  }

  beta_2 <- solve_fold(idx_eval = idx_S2, idx_train = idx_S1)
  beta_1 <- solve_fold(idx_eval = idx_S1, idx_train = idx_S2)

  return((beta_1 + beta_2) / 2)
}

#' @title Estimate nonparametric conditional meanimile
#'
#' @description
#'    Estimates a conditional meanimile in nonparametric way.
#'    This function acts as a unified wrapper, allowing the user to seamlessly switch
#'    between the square loss formulation and the general loss formulation.
#'
#' @param X A numeric matrix of covariates (n x d).
#' @param Y A numeric vector of the response variable.
#' @param X0 A numeric matrix of evaluation points (m x d) where the curve should be estimated.
#' @param d_tau A function representing the density function of the
#'    distributional weight function D_tau.
#' @param tau A numeric risk level/index. Argument of d_tau function.
#' @param h_x_loc A numeric vector of local spatial bandwidths for the covariates X.
#' @param h_x_cdf A numeric vector of bandwidths for the covariates X used in the CDF estimation.
#' @param h_y_cdf A numeric scalar bandwidth for the response variable Y used in the CDF estimation.
#' @param loss_type Character string specifying the loss formulation (\code{"square"} or \code{"general"}).
#' @param lossDerivative A function defining the derivative of the loss function. Required for \code{"general"}.
#' @param delta Optional numeric parameter for the loss function. Only for \code{"general"}.
#'
#' @return A numeric vector of length m, containing the estimated meanimile predictions at each point in X0.
#' @export
#' @examples
#' set.seed(123)
#' n <- 300
#'
#' # 1. Simulate 1D Non-linear Data (Sine Wave)
#' X <- matrix(runif(n, -2, 2), ncol = 1)
#' Y <- sin(X[, 1] * 1.5) + rnorm(n, sd = 0.4)
#'
#' # 2. Define Evaluation Grid
#' X0 <- matrix(seq(-2, 2, length.out = 50), ncol = 1)
#'
#' # 3. Define Functions
#' d_tau_minvar <- function(u, tau) {
#'   (tau + 1) * u^tau
#' }
#' loss_deriv_expectile <- function(x, c, delta) {
#'   -2 * ifelse(x > c, delta, 1 - delta) * (x - c)
#' }
#'
#' # 4. Fit Square Loss Nonparametric
#' preds_sq <- MeanimileNonparametricRegression(
#'   X = X, Y = Y, X0 = X0, d_tau = d_tau_minvar, tau = 2,
#'   h_x_loc = 0.4, h_x_cdf = 0.4, h_y_cdf = 0.4, loss_type = "square"
#' )
#'
#' # 5. Fit General Loss Nonparametric (Expectile)
#' preds_gen <- MeanimileNonparametricRegression(
#'   X = X, Y = Y, X0 = X0, d_tau = d_tau_minvar, tau = 2,
#'   h_x_loc = 0.4, h_x_cdf = 0.4, h_y_cdf = 0.4, loss_type = "general",
#'   lossDerivative = loss_deriv_expectile, delta = 0.9
#' )
MeanimileNonparametricRegression <- function(X, Y, X0, d_tau, tau,
                                             h_x_loc, h_x_cdf, h_y_cdf,
                                             loss_type = c("square", "general"),
                                             lossDerivative = NULL, delta = NULL) {
  loss_type <- match.arg(loss_type)
  X <- as.matrix(X)
  X0 <- as.matrix(X0)

  if (ncol(X) != ncol(X0)) stop("X and X0 must have the same number of columns.")

  if (length(h_x_loc) == 1) h_x_loc <- rep(h_x_loc, ncol(X))
  if (length(h_x_cdf) == 1) h_x_cdf <- rep(h_x_cdf, ncol(X))

  if (loss_type == "square") {
    return(fit_nonpar_square(X, Y, X0, d_tau, tau, h_x_loc, h_x_cdf, h_y_cdf))
  } else {
    if (is.null(lossDerivative)) stop("lossDerivative required for general loss.")
    return(fit_nonpar_general(X, Y, X0, d_tau, tau, h_x_loc, h_x_cdf, h_y_cdf, lossDerivative, delta))
  }
}

# -------------------------------------------------------------------------
# Helper: Spatial Kernel Weights
# -------------------------------------------------------------------------
compute_spatial_weights <- function(X, x0, h_x_loc) {
  W_spatial <- rep(1, nrow(X))
  for (j in seq_len(ncol(X))) {
    W_spatial <- W_spatial * stats::dnorm((X[, j] - x0[j]) / h_x_loc[j])
  }
  return(W_spatial)
}

# -------------------------------------------------------------------------
# Internal Engine: Square Loss
# -------------------------------------------------------------------------
fit_nonpar_square <- function(X, Y, X0, d_tau, tau, h_x_loc, h_x_cdf, h_y_cdf) {
  n <- nrow(X)
  m <- nrow(X0)
  preds <- numeric(m)

  for (i in seq_len(m)) {
    x0 <- X0[i, ]

    x0_mat <- matrix(x0, nrow = n, ncol = length(x0), byrow = TRUE)
    F_hat <- ConditionalCDF(
      Y_eval = Y, X_eval = x0_mat,
      Y_train = Y, X_train = X,
      h_y = h_y_cdf, h_x = h_x_cdf
    )

    W_cdf <- d_tau(F_hat, tau)
    valid <- !is.na(W_cdf)

    # Spatial weights
    W_spatial <- compute_spatial_weights(X, x0, h_x_loc)
    W_total <- W_cdf * W_spatial

    # Local Linear Math
    X_loc <- -sweep(X, 2, x0, FUN = "-")
    X_loc <- cbind(1, X_loc)

    fit <- stats::lm.wfit(
      x = X_loc[valid, , drop = FALSE],
      y = Y[valid], w = W_total[valid]
    )
    preds[i] <- fit$coefficients[1]
  }

  return(preds)
}

# -------------------------------------------------------------------------
# Internal Engine: General Loss
# -------------------------------------------------------------------------
fit_nonpar_general <- function(X, Y, X0, d_tau, tau, h_x_loc, h_x_cdf, h_y_cdf, lossDerivative, delta) {
  n <- nrow(X)
  m <- nrow(X0)
  preds <- numeric(m)

  solve_local_root <- function(Y_val, X_loc_val, W_total_val) {
    obj_fun <- function(beta) {
      preds <- as.vector(X_loc_val %*% beta)
      if (is.null(delta)) {
        derivs <- lossDerivative(Y_val, preds)
      } else {
        derivs <- lossDerivative(Y_val, preds, delta)
      }
      eq_sums <- colSums(X_loc_val * (W_total_val * derivs))
      return(sum(eq_sums^2))
    }

    start_beta <- stats::lm.wfit(x = X_loc_val, y = Y_val, w = W_total_val)$coefficients
    start_beta[is.na(start_beta)] <- 0


    opt_res <- stats::optim(par = start_beta, fn = obj_fun, method = "BFGS")
    return(opt_res$par[1])
  }

  for (i in seq_len(m)) {
    x0 <- X0[i, ]

    x0_mat <- matrix(x0, nrow = n, ncol = length(x0), byrow = TRUE)
    F_hat <- ConditionalCDF(
      Y_eval = Y, X_eval = x0_mat,
      Y_train = Y, X_train = X,
      h_y = h_y_cdf, h_x = h_x_cdf
    )

    W_cdf <- d_tau(F_hat, tau)
    valid <- !is.na(W_cdf)

    # Spatial weights
    W_spatial <- compute_spatial_weights(X, x0, h_x_loc)
    W_total <- W_cdf * W_spatial

    X_loc <- -sweep(X, 2, x0, FUN = "-")
    X_loc <- cbind(1, X_loc)[valid, , drop = FALSE]

    preds[i] <- solve_local_root(Y[valid], X_loc, W_total[valid])
  }

  return(preds)
}

#' @title  Estimate portfolio meanimile
#'
#' @description
#'    Estimates the risk of an aggregated portfolio using the
#'    meanimile framework. Supports parametric and nonparametric modeling
#'    of marginal distributions and copula.
#'
#' @param data A numeric matrix or data.frame (n observations x d assets).
#' @param weights A numeric vector of portfolio weights summing to 1.
#' @param d_tau A function representing the density function of the
#'    distributional weight function D_tau.
#' @param tau A numeric risk level/index (e.g., 0.95).
#'     Argument of d_tau function.
#' @param lossDerivative Function defining the derivative of the loss function.
#' @param delta Optional numeric parameter for the loss function (default:NULL).
#' @param copula_obj An unfitted 'copula' object (e.g., \code{copula::gumbelCopula(dim=3)}).
#'   If \code{NULL}, an Empirical Beta Copula is used.
#' @param margin_dists A character vector of base R distribution root names for \code{fitdistrplus::fitdist}
#'   (e.g., \code{c("norm", "exp", "weibull")}). If \code{NULL}, empirical margins are used.
#' @param N Integer. Number of Monte Carlo simulations to draw (default: 100 000).
#' @param grid_size An integer defining the resolution of the fallback grid (default: 1000).
#'
#' @return  A numeric scalar representing the estimated meanimile.
#' @export
#' @examples
#'
#' gumbel.cop <- copula::gumbelCopula(10 / 9, dim = 3)
#' myMvdX <- copula::mvdc(
#'   copula = gumbel.cop, margins = c("norm", "norm", "exp"),
#'   paramMargins = list(
#'     list(mean = 0, sd = 1),
#'     list(mean = 0, sd = 1),
#'     list(rate = 1)
#'   )
#' )
#' X <- copula::rMvdc(500, myMvdX)
#'
#' d_tau_expectile <- function(u, tau) {
#'   1
#' }
#' lossDerivativeExpectiles <- function(x, c, delta) {
#'   -2 * ifelse(x > c, delta, 1 - delta) * (x - c)
#' }
#' gumbelCopula <- copula::gumbelCopula(dim = 3)
#' margin_dists <- c("norm", "norm", "exp")
#' weights <- c(1 / 3, 1 / 3, 1 / 3)
#' PortfolioMeanimile(
#'   data = X, weights, d_tau_expectile, tau = 0, lossDerivativeExpectiles, delta = 0.95,
#'   copula_obj = gumbelCopula, margin_dists = margin_dists, N = 100000, grid_size = 1000
#' )
#'
#' @references
#' D. Debrauwer and I. Gijbels (2026)
#' Copula-based estimation of meanimiles of aggregated risks.
#' Metrika
#' doi:https://doi.org/10.1007/s00184-026-01022-9
PortfolioMeanimile <- function(data, weights, d_tau, tau, lossDerivative, delta = NULL,
                               copula_obj = NULL, margin_dists = NULL, N = 100000, grid_size = 1000) {
  # Input Validation
  data <- as.matrix(data)
  if (!is.numeric(data)) stop("'data' must be a numeric matrix or data.frame.")
  if (any(is.na(data))) stop("'data' contains missing values. Please handle NAs before fitting.")

  n <- nrow(data)
  d <- ncol(data)

  if (d <= 1) stop("Dimension must be at least two.")
  if (!is.numeric(weights)) stop("'weights' must be numeric.")
  if (length(weights) != d) stop(sprintf("Length of weights (%d) must match number of assets (%d).", length(weights), d))
  if (abs(sum(weights) - 1) > 1e-5) stop("Portfolio weights must sum to 1.")
  if (N <= 0 || grid_size <= 0) stop("'N' and 'grid_size' must be positive integers.")

  is_param_copula <- !is.null(copula_obj)
  is_param_margins <- !is.null(margin_dists)

  if (is_param_margins && length(margin_dists) != d) {
    stop("If 'margin_dists' is provided, it must have a distribution name for every column in 'data'.")
  }

  # Estimate Margins & Compute Pseudo-Observations
  U_data <- matrix(NA, nrow = n, ncol = d)
  fitted_margin_params <- list()

  for (j in 1:d) {
    if (is_param_margins) {
      # User passes the actual root (e.g., "norm", "weibull", "exp")
      r_root <- margin_dists[j]

      # Fit safely using fitdistrplus
      fit <- tryCatch(
        {
          fitdistrplus::fitdist(data[, j], distr = r_root)
        },
        error = function(e) {
          stop(sprintf("Failed to fit '%s' on column %d. Check your data or distribution choice. Error: %s", r_root, j, e$message))
        }
      )

      fitted_margin_params[[j]] <- as.list(fit$estimate)

      # Transform to Uniform
      p_func_name <- paste0("p", r_root)
      if (!exists(p_func_name, mode = "function")) {
        stop(sprintf("Probability function %s not found.", p_func_name))
      }
      p_func <- get(p_func_name, mode = "function")

      U_data[, j] <- do.call(p_func, c(list(q = data[, j]), fitted_margin_params[[j]]))
    } else {
      # Nonparametric Margins
      U_data[, j] <- rank(data[, j]) / (n + 1)
    }
  }

  # Estimate Copula & Draw N Samples
  if (is_param_copula) {
    if (!inherits(copula_obj, "copula")) stop("'copula_obj' must be an object of class 'copula'.")

    fitted_copula <- tryCatch(
      {
        copula::fitCopula(copula_obj, data = U_data, method = "mpl", estimate.variance = FALSE)@copula
      },
      error = function(e) {
        stop(paste("Failed to fit parametric copula. Error:", e$message))
      }
    )

    U_sim <- copula::rCopula(N, fitted_copula)
  } else {
    # Nonparametric Copula (Empirical Beta Copula with smoothing)
    ecop <- copula::empCopula(U_data, smoothing = "beta")
    U_sim <- copula::rCopula(N, copula = ecop)
  }

  # Transform U_sim back to X_sim via Inverse Margins
  X_sim <- matrix(NA, nrow = N, ncol = d)

  for (j in 1:d) {
    if (is_param_margins) {
      q_func_name <- paste0("q", margin_dists[j])
      if (!exists(q_func_name, mode = "function")) stop(sprintf("Quantile function %s not found.", q_func_name))
      q_func <- get(q_func_name, mode = "function")

      X_sim[, j] <- do.call(q_func, c(list(p = U_sim[, j]), as.list(fitted_margin_params[[j]])))
    } else {
      X_sim[, j] <- stats::quantile(data[, j], probs = U_sim[, j], type = 1, names = FALSE)
    }
  }

  # Aggregate Portfolio and Estimate
  Z_sim <- as.vector(X_sim %*% weights)

  result <- MeanimileEstimator(
    d_tau = d_tau,
    tau = tau,
    lossDerivative = lossDerivative,
    delta = delta,
    sample = Z_sim,
    grid_size = grid_size
  )

  return(result)
}

#'
#' @title Estimate a univariate meanimile
#'
#' @description
#'    Calculates the empirical meanimile for a given (univariate) data sample,
#'    weight function, and loss derivative.
#'
#' @param d_tau A function representing the density function of the
#'    distributional weight function D_tau.
#' @param tau A numeric risk level/index (e.g., 0.95).
#'     Argument of d_tau function.
#' @param lossDerivative Function defining the derivative of the loss function.
#' @param delta Optional numeric parameter for the loss function (default:\code{NULL}).
#' @param sample A numeric vector of univariate data.
#' @param grid_size An integer defining the resolution of the fallback grid
#'     (default: 1000).
#'
#' @return A numeric scalar representing the estimated meanimile.
#' @export
#'
#' @examples
#' set.seed(123)
#' x <- rnorm(100)
#' d_tau_expectile <- function(u, tau) {
#'   1
#' }
#' lossDerivativeExpectiles <- function(x, c, delta) {
#'   -2 * ifelse(x > c, delta, 1 - delta) * (x - c)
#' }
#' MeanimileEstimator(d_tau_expectile, tau = 0, lossDerivativeExpectiles,
#'     delta = 0.95, sample = x)
#'
#' @references
#' D. Debrauwer, I. Gijbels, and K. Herrmann. (2026)
#' On a general class of functionals: Statistical inference and
#' application to risk measures
#' Electronic Journal of Statistics
#' doi:https://doi.org/10.1214/25-EJS2391

MeanimileEstimator <- function(d_tau, tau, lossDerivative, delta = NULL, sample, grid_size = 1000) {
  if (!is.numeric(sample)) stop("'sample' must be a numeric vector.")

  x_sorted <- sort(sample[!is.na(sample)])
  n <- length(x_sorted)

  if (n == 0) stop("No non-missing data provided in 'sample'.")
  if (!is.function(d_tau)) stop("'d_tau' must be a function.")
  if (!is.function(lossDerivative)) stop("'lossDerivative' must be a function.")

  ranks <- seq_len(n) / (n + 1)
  d_tauWeights <- d_tau(ranks, tau)

  if (is.null(delta)) {
    lambdaHat <- function(c) sum(d_tauWeights * lossDerivative(x_sorted, c))
  } else {
    lambdaHat <- function(c) sum(d_tauWeights * lossDerivative(x_sorted, c, delta))
  }

  res <- tryCatch(
    {
      root_res <- stats::uniroot(lambdaHat, interval = c(min(x_sorted), max(x_sorted)), extendInt = "yes")
      root_res$root
    },
    error = function(e) {
      grid <- seq(min(x_sorted), max(x_sorted), length.out = grid_size)
      grid_evals <- vapply(grid, lambdaHat, FUN.VALUE = numeric(1))
      grid[which.min(abs(grid_evals))]
    }
  )

  return(res)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MeanimileLinearRegression.R
\name{MeanimileLinearRegression}
\alias{MeanimileLinearRegression}
\title{Estimate linear conditional meanimile}
\usage{
MeanimileLinearRegression(
  X,
  Y,
  d_tau,
  tau,
  h_x,
  h_y,
  loss_type = c("square", "general"),
  lossDerivative = NULL,
  delta = NULL
)
}
\arguments{
\item{X}{A numeric matrix of covariates (n x d).}

\item{Y}{A numeric vector of the response variable.}

\item{d_tau}{A function representing the density function of the
distributional weight function D_tau.}

\item{tau}{A numeric risk level/index. Argument of d_tau function.}

\item{h_x}{A numeric vector of bandwidths for the covariates X.}

\item{h_y}{A numeric scalar bandwidth for the response variable Y.}

\item{loss_type}{A character string specifying the loss formulation. Must be either \code{"square"} (default) or \code{"general"}.}

\item{lossDerivative}{A function defining the derivative of the loss function. Required only if \code{loss_type = "general"}.}

\item{delta}{Optional numeric parameter for the loss function. Used only if \code{loss_type = "general"}.}
}
\value{
A numeric vector of estimated regression coefficients (including the intercept).
}
\description{
Estimates the parameters of a linear conditional meanimile model using a two-fold
sample splitting procedure to mitigate bias from the conditional CDF estimation.
This function acts as a unified wrapper, allowing the user to seamlessly switch
between the square loss formulation and the general loss formulation.
}
\examples{
set.seed(123)
n <- 400
X <- matrix(rnorm(n * 2), ncol = 2)
Y <- 0.9 * X[, 1] + 0.5 * X[, 2] + rnorm(n)
d_tau_minvar <- function(u, tau) {
  (tau + 1) * u^tau
}
lossDerivativeExpectiles <- function(x, c, delta) {
  -2 * ifelse(x > c, delta, 1 - delta) * (x - c)
}

# 1. Square Loss
MeanimileLinearRegression(X, Y,
  d_tau = d_tau_minvar, tau = 2,
  h_x = c(0.4, 0.4), h_y = 0.4, loss_type = "square"
)

# 2. General Loss
MeanimileLinearRegression(X, Y,
  d_tau = d_tau_minvar, tau = 2,
  h_x = c(0.4, 0.4), h_y = 0.4, loss_type = "general",
  lossDerivative = lossDerivativeExpectiles, delta = 0.9
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ConditionalCDF.R
\name{ConditionalCDF}
\alias{ConditionalCDF}
\title{Estimate conditional cumulative distribution function}
\usage{
ConditionalCDF(Y_eval, X_eval, Y_train, X_train, h_y, h_x)
}
\arguments{
\item{Y_eval}{A numeric vector of Y values where the CDF should be evaluated.}

\item{X_eval}{A numeric matrix of X values where the CDF should be evaluated.}

\item{Y_train}{A numeric vector of training Y values.}

\item{X_train}{A numeric matrix of training X values.}

\item{h_y}{A numeric scalar representing the bandwidth for the
response variable Y.}

\item{h_x}{A numeric vector representing the bandwidths for the covariates X.}
}
\value{
A numeric vector of estimated CDF probabilities.
}
\description{
Computes a doubly smoothed Nadaraya-Watson estimator for the conditional
cumulative distribution function.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MeanimileEstimator.R
\name{MeanimileEstimator}
\alias{MeanimileEstimator}
\title{Estimate a univariate meanimile}
\usage{
MeanimileEstimator(
  d_tau,
  tau,
  lossDerivative,
  delta = NULL,
  sample,
  grid_size = 1000
)
}
\arguments{
\item{d_tau}{A function representing the density function of the
distributional weight function D_tau.}

\item{tau}{A numeric risk level/index (e.g., 0.95).
Argument of d_tau function.}

\item{lossDerivative}{Function defining the derivative of the loss function.}

\item{delta}{Optional numeric parameter for the loss function (default:\code{NULL}).}

\item{sample}{A numeric vector of univariate data.}

\item{grid_size}{An integer defining the resolution of the fallback grid
(default: 1000).}
}
\value{
A numeric scalar representing the estimated meanimile.
}
\description{
Calculates the empirical meanimile for a given (univariate) data sample,
weight function, and loss derivative.
}
\examples{
set.seed(123)
x <- rnorm(100)
d_tau_expectile <- function(u, tau) {
  1
}
lossDerivativeExpectiles <- function(x, c, delta) {
  -2 * ifelse(x > c, delta, 1 - delta) * (x - c)
}
MeanimileEstimator(d_tau_expectile, tau = 0, lossDerivativeExpectiles,
    delta = 0.95, sample = x)

}
\references{
D. Debrauwer, I. Gijbels, and K. Herrmann. (2026)
On a general class of functionals: Statistical inference and
application to risk measures
Electronic Journal of Statistics
doi:https://doi.org/10.1214/25-EJS2391
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PortfolioMeanimile.R
\name{PortfolioMeanimile}
\alias{PortfolioMeanimile}
\title{Estimate portfolio meanimile}
\usage{
PortfolioMeanimile(
  data,
  weights,
  d_tau,
  tau,
  lossDerivative,
  delta = NULL,
  copula_obj = NULL,
  margin_dists = NULL,
  N = 1e+05,
  grid_size = 1000
)
}
\arguments{
\item{data}{A numeric matrix or data.frame (n observations x d assets).}

\item{weights}{A numeric vector of portfolio weights summing to 1.}

\item{d_tau}{A function representing the density function of the
distributional weight function D_tau.}

\item{tau}{A numeric risk level/index (e.g., 0.95).
Argument of d_tau function.}

\item{lossDerivative}{Function defining the derivative of the loss function.}

\item{delta}{Optional numeric parameter for the loss function (default:NULL).}

\item{copula_obj}{An unfitted 'copula' object (e.g., \code{copula::gumbelCopula(dim=3)}).
If \code{NULL}, an Empirical Beta Copula is used.}

\item{margin_dists}{A character vector of base R distribution root names for \code{fitdistrplus::fitdist}
(e.g., \code{c("norm", "exp", "weibull")}). If \code{NULL}, empirical margins are used.}

\item{N}{Integer. Number of Monte Carlo simulations to draw (default: 100 000).}

\item{grid_size}{An integer defining the resolution of the fallback grid (default: 1000).}
}
\value{
A numeric scalar representing the estimated meanimile.
}
\description{
Estimates the risk of an aggregated portfolio using the
meanimile framework. Supports parametric and nonparametric modeling
of marginal distributions and copula.
}
\examples{

gumbel.cop <- copula::gumbelCopula(10 / 9, dim = 3)
myMvdX <- copula::mvdc(
  copula = gumbel.cop, margins = c("norm", "norm", "exp"),
  paramMargins = list(
    list(mean = 0, sd = 1),
    list(mean = 0, sd = 1),
    list(rate = 1)
  )
)
X <- copula::rMvdc(500, myMvdX)

d_tau_expectile <- function(u, tau) {
  1
}
lossDerivativeExpectiles <- function(x, c, delta) {
  -2 * ifelse(x > c, delta, 1 - delta) * (x - c)
}
gumbelCopula <- copula::gumbelCopula(dim = 3)
margin_dists <- c("norm", "norm", "exp")
weights <- c(1 / 3, 1 / 3, 1 / 3)
PortfolioMeanimile(
  data = X, weights, d_tau_expectile, tau = 0, lossDerivativeExpectiles, delta = 0.95,
  copula_obj = gumbelCopula, margin_dists = margin_dists, N = 100000, grid_size = 1000
)

}
\references{
D. Debrauwer and I. Gijbels (2026)
Copula-based estimation of meanimiles of aggregated risks.
Metrika
doi:https://doi.org/10.1007/s00184-026-01022-9
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/MeanimileNonparametricRegression.R
\name{MeanimileNonparametricRegression}
\alias{MeanimileNonparametricRegression}
\title{Estimate nonparametric conditional meanimile}
\usage{
MeanimileNonparametricRegression(
  X,
  Y,
  X0,
  d_tau,
  tau,
  h_x_loc,
  h_x_cdf,
  h_y_cdf,
  loss_type = c("square", "general"),
  lossDerivative = NULL,
  delta = NULL
)
}
\arguments{
\item{X}{A numeric matrix of covariates (n x d).}

\item{Y}{A numeric vector of the response variable.}

\item{X0}{A numeric matrix of evaluation points (m x d) where the curve should be estimated.}

\item{d_tau}{A function representing the density function of the
distributional weight function D_tau.}

\item{tau}{A numeric risk level/index. Argument of d_tau function.}

\item{h_x_loc}{A numeric vector of local spatial bandwidths for the covariates X.}

\item{h_x_cdf}{A numeric vector of bandwidths for the covariates X used in the CDF estimation.}

\item{h_y_cdf}{A numeric scalar bandwidth for the response variable Y used in the CDF estimation.}

\item{loss_type}{Character string specifying the loss formulation (\code{"square"} or \code{"general"}).}

\item{lossDerivative}{A function defining the derivative of the loss function. Required for \code{"general"}.}

\item{delta}{Optional numeric parameter for the loss function. Only for \code{"general"}.}
}
\value{
A numeric vector of length m, containing the estimated meanimile predictions at each point in X0.
}
\description{
Estimates a conditional meanimile in nonparametric way.
This function acts as a unified wrapper, allowing the user to seamlessly switch
between the square loss formulation and the general loss formulation.
}
\examples{
set.seed(123)
n <- 300

# 1. Simulate 1D Non-linear Data (Sine Wave)
X <- matrix(runif(n, -2, 2), ncol = 1)
Y <- sin(X[, 1] * 1.5) + rnorm(n, sd = 0.4)

# 2. Define Evaluation Grid
X0 <- matrix(seq(-2, 2, length.out = 50), ncol = 1)

# 3. Define Functions
d_tau_minvar <- function(u, tau) {
  (tau + 1) * u^tau
}
loss_deriv_expectile <- function(x, c, delta) {
  -2 * ifelse(x > c, delta, 1 - delta) * (x - c)
}

# 4. Fit Square Loss Nonparametric
preds_sq <- MeanimileNonparametricRegression(
  X = X, Y = Y, X0 = X0, d_tau = d_tau_minvar, tau = 2,
  h_x_loc = 0.4, h_x_cdf = 0.4, h_y_cdf = 0.4, loss_type = "square"
)

# 5. Fit General Loss Nonparametric (Expectile)
preds_gen <- MeanimileNonparametricRegression(
  X = X, Y = Y, X0 = X0, d_tau = d_tau_minvar, tau = 2,
  h_x_loc = 0.4, h_x_cdf = 0.4, h_y_cdf = 0.4, loss_type = "general",
  lossDerivative = loss_deriv_expectile, delta = 0.9
)
}
